;graphlib library by the doorsteam, comment by C.Couffignal & Xavier VASSOR
	include "doorsos.h"

	xdef	_ti89
	xdef	_ti92plus

	xdef	graphlib@0000	;func fill
	xdef	graphlib@0001	;func put_sprite
	xdef	graphlib@0002	;func small_box
	xdef	graphlib@0003	;func box
	xdef	graphlib@0004	;func frame
	xdef	graphlib@0005	;func clr_scr
	xdef	graphlib@0006	;func vert
	xdef	graphlib@0007	;func horiz
	xdef	graphlib@0008	;func bigbox
	xdef	graphlib@0009	;func scrtomem
	xdef	graphlib@000A	;func memtoscr
	xdef	graphlib@000B	;func put_sprite_mask
	xdef	graphlib@000C	;func put_sprite2
	xdef	graphlib@000D	;var  choosescreen
	xdef	graphlib@000E	;func gray2
	xdef	graphlib@000F	;func gray4
	xdef	graphlib@0010	;func gray7
	xdef	graphlib@0011	;var  plane0
	xdef	graphlib@0012	;var  plane1
	xdef	graphlib@0013	;var  plane2
	xdef	graphlib@0014	;func clr_scr2
	xdef	graphlib@0015	;func show dialog
	xdef	graphlib@0016	;func clear dialog
	xdef	graphlib@0017	;func line
	xdef	graphlib@0018	;func erase_frame
	xdef	graphlib@0019	;func frame_rect
	xdef	graphlib@001A	;func getlength
	xdef    _library

graphlib@001A:
getlength:
; input:
; a0 : pointer to a string
; output:
; d3.w = length of the string, in pixels, in the current font
; d4.w = height of the string, in pixels, in the current font

	movem.l	d0-d2/d5-d7/a0-a6,-(a7)	; pushes regs
	clr.w		d4				; height = 0
	clr.w		d3				; length = 0
	jsr		doorsos::FontGetSys		; d0.b = current font
	lea		doorsos::font_small,a1	; a1 points to the small font table
\retour
	tst.b		(a0)			; end of the string ?
	beq		\fin			; yes -> fin
	tst.b		d0			; currentfont = small ?
	beq		\font0			; yes -> font0
	cmp.b		#1,d0			; font = medium ?
	beq		\font1			; yes -> font1
	moveq.b	#10,d4			; else : font = big; height = 10
	addq.b		#8,d3			; length += 8 for each char
	bra		\byte			; go on

\font1 moveq.b	#8,d4			; height = 8
	addq.b		#6,d3			; length += 6 for each char
	bra		\byte			; go on

\font0 clr.w		d1
	moveq.b	#5,d4			; height = 5
	move.b		(a0),d1		; d1 = char = index in the font table
	mulu		#6,d1			; *6 because each font sprite is 6 bytes long
	add.b		0(a1,d1.w),d3		; 0(a1,d1.w) is the length of the d1 char

\byte	addq.l		#1,a0			; string pointer ++
	bra		\retour		; test again
\fin	movem.l	(a7)+,d0-d2/d5-d7/a0-a6	; pops regs
	rts

graphlib@0018
erase_rect:
;----------------------------------------------------------------------------
; erase_rect(rect r)
;
; Function: Fills the rectangle {r} with solid white.;
; Return: nothing
;----------------------------------------------------------------------------
	movem.l		d0-d7/a0-a6,-(a7)
	lea		64(a7),a7
	move.w		(a7)+,d0			;x1
	move.w		(a7)+,d1			;y1
	move.w		(a7)+,d2			;x2
	move.w		(a7)+,d3			;y2
	lea		-72(a7),a7			
	sub.w		d0,d2			;d2 = width
	sub.w		d1,d3			;d3 = heigth
	moveq.w	 #1,d4
	bsr		fill
	movem.l 	(a7)+,d0-d7/a0-a6
	rts

graphlib@0019
;----------------------------------------------------------------------------
; frame_rect(rect r)
;
; Function: Draws the rectangle frame {r}.
;
; Return: nothing
;----------------------------------------------------------------------------
frame_rect:
	movem.l		d0-d7/a0-a6,-(a7)
	lea		64(a7),a7
	move.w		(a7)+,d0			;x1
	move.w		(a7)+,d1			;y1
	move.w		(a7)+,d4			;x2
	move.w		(a7)+,d5			;y2
	lea		-72(a7),a7
	sub.w		d0,d4			;d4 = width
	sub.w		d1,d5			;d5 = heigth
	bsr		frame
	movem.l 	(a7)+,d0-d7/a0-a6
	rts

graphlib@0000:
fill:
;--------------------------------------------------------------
;fill(x,y,width,height,color)
;
;   Fills the rectangle delimited by x, y, width and lenght with 
;  the specified color
;
;Input:d0.w = x
;	d1.w = y
;	d2.w = width
;	d3.w = height
;	d4.w = color:	0 -> Video Invert
;			1 -> White
;			2 -> Black
;
;Output: nothing
;	NO REGISTERS DESTROYED
;--------------------------------------------------------------
	movem.l	d0-d7/a0-a6,-(a7)	; save registers
	exg.w		d4,d3			;  d3 in d4 and d4 in d3 because of horiz: color in d3
	add.w		d0,d2			;  width + x1=x2
\line	bsr		horiz			;  disp the line x1,y1,x2,y1
	addq.w		#1,d1			;+1 to y1
	dbra		d4,\line		;make a loop d4 (height) time
	movem.l	(a7)+,d0-d7/a0-a6	;restore registers
 	rts 					;quit func

put_sprite_all:
;d0 = x
;d1 = y
;d3 = mask if d5 = 0
;d5 = 0 if mask = d3
;d6 = 0 if mask = (a2)
	movem.l	d0-d7/a0-a6,-(a7)
	move.w	d0,d4
	bsr	loadscreen	; a1 points to the adress of the screen
	mulu.w	#30,d1		; y * 30
	add.l	d1,a1		; + a1
	lsr.w	#3,d4		; x/8
	add.w	d4,a1		; -> a1 = adresse where we'll put the sprite
	move.w	d5,d1		; d1 = d5

	move.w	(a0)+,d2 	; d2 = height
	move.w	(a0)+,d5 	; d5 = width in bytes
	tst.l	d6		; is the mask already at (a2) ?
	beq	\maskOK	; yes !
	move.l	a0,a2		; a2 = a0
	move.w	d5,d4		; d4 = width
	mulu	d2,d4		; d4 = width * height
	add.l	d4,a2		; a2 points to the mask

\maskOK
	not.w		d0	; not x
	and.w		#7,d0	; and #%111,x
	moveq.w	#7,d4	;
	sub.w		d0,d4	; d4 = 7 - ((not x) and #%111)
\uneln tst.w		d2	; height = 0 ?
	beq		\fin	; yes -> \fin

	movem.l	d0-d7/a0-a6,-(a7) 	; We will display a line of the sprite
	bsr		firstbyte		; display the first byte (8 pxls)
	subq.w		#1,d5			; width --
\put	tst.w		d5			; width == 0 ?
	ble		\last			; yes -> last
	bsr		putbyte		; else display another byte (8 pixels)
	dbra		d5,\put		; width --, loop
\last	bsr		lastbyte		; display the last byte (8 pixels)
	movem.l	(a7)+,d0-d7/a0-a6	; we have displayed a line =)

	subq.w		#1,d2			; height --
	add.l		d5,a0			; sprite pointer += width -> points to the next line
	add.l		#30,a1			; screen pointer += 30 -> points to the next line
	add.l		d5,a2			; mask pointer += width  -> points to the next line
	bra		\uneln			; display the other lines
\fin	movem.l	(a7)+,d0-d7/a0-a6
	rts

putbyte:
;a0=sprite adress
;a1=screen adress
;d4=nb of bits to shift to the right
	subq.l	#1,a0		;le byte  mettre
	move.b	(a0)+,d7	; d7.b = previous byte
	lsl.w	#8,d7		; d7 << 8
	move.b	(a0)+,d7	; d7.b = current byte
	lsr.w	d4,d7		; d7.w >> d4
	tst.w	d1		; is the mask in d3.b ?
	beq	disp1		; yes -> disp1
	subq.l	#1,a2		; no -> loads it from (a2)
	move.b	(a2)+,d3	; d3.b = previous byte
	lsl.w	#8,d3		; d3 << 8
	move.b	(a2)+,d3	; d3.b = current byte
	lsr.w	d4,d3		; d3.w >> d4
disp1: move.l	d3,-(a7)	; saves d3
disp:	move.b	(a1),d6	; d6.b = current byte of the screen
	not.b	d3		; not mask
	and.b	d3,d6		; and mask.b, screen.b
	or.b	d6,d7		; or with the sprite
	move.b	d7,(a1)+	; put it on the screen ! :)
	move.l	(a7)+,d3	; restores d3 
	rts

firstbyte:
;a0=sprite adress
;a1=screen adress
;d4=nb of bits to shift to the right

	clr.w	d7		; d7 = 0
	move.b	(a0)+,d7	; d7.b = byte of the sprite
	lsr.w	d4,d7		; d7 >> d4
	tst.w	d1		; is the mask at d3.b ?
	beq	lsr		; yes -> shift d3 and display
	clr.w	d3		; else mask = 0
	move.b	(a2)+,d3	; loads it from a2
	bra	lsr		; shift d3 and display

lastbyte:
;a0=sprite adress
;a1=screen adress
;d4=nb of bits to shift to the right

	subq.l	#1,a0		; 
	move.b	(a0)+,d7	; d7.b = previous byte of the sprite
	lsl.w	#8,d7		; d7 << 8
	clr.b	d7		; d7.b = 0
	lsr.w	d4,d7		; d7 >> d4
	tst.w	d1		; is the mask at d3.b ?
	beq	lsr2		; yes -> lsr2
	subq.l	#1,a2		; no: loads it from (a2)
	move.b	(a2)+,d3	; d3 = mask
lsr2:	lsl.w	#8,d3		; mask << 8
	clr.b	d3		; mask.b = 0
lsr:	move.l d3,-(a7)	; saves the mask
	lsr.w	d4,d3		; mask >> d4
	bra	disp		; display the byte :)

graphlib@000B
put_sprite_mask:
;d0 = x
;d1 = y
;a0 = sprite
;d3.b = mask for each 8 pixels of the screen

	movem.l	d5-d6,-(a7)
	clr.l		d5		; mask = d3
	clr.l		d6		; just to make the main function think a mask is at (a2), but in fact it is at d3.b =)
	bra		putsprite	; jump..

graphlib@0001:
put_sprite:
;	d0.w = x
;	d1.w = y
;	a0.l = adress of the sprite & the mask

	movem.l	d5-d6,-(a7)
	moveq.l	#$4F,d5	; mask is not at d3.b
	move.l		d5,d6		; neither at (a2)
putsprite:
	bsr		put_sprite_all	; main put_sprite function
	movem.l	(a7)+,d5-d6
	rts

graphlib@000C
put_sprite2
;d0 = x
;d1 = y
;a0 = sprite
;a2 = mask
	movem.l	d5-d6,-(a7)
	clr.l		d6		; sprite is at (a2)
	moveq.l	#$4F,d5	; but not at d3.b
	bra		putsprite

graphlib@0002:
;--------------------------------------------------------------
;smallbox(title)
;
;  Draws a box in the middle of the screen
;
;Input:	a0.l = title of the box
;
;Output: nothing
;	NO REGISTERS DESTROYED
;--------------------------------------------------------------
smallbox:
	movem.l   	d0-d7/a0-a6,-(a7)  	; save registers
	tst.b		CALCULATOR		; check if it is a 89 or a 92+
	bne		\92
;here for 89
	moveq.w	#25,d0			;x
	moveq.w	#20,d1			;y
	moveq.w	#110,d2		;width
	moveq.w	#60,d3			;height
; parameters for drawbox
	bra		\drawbox
\92						; here for 92+
	moveq.w	#40,d0			;x1
	moveq.w	#25,d1			;y1
	move.w		#158,d2		;width
	moveq.w	#76,d3			;height
\drawbox	
	bsr		box			; disp a box with "small box" parameters
	movem.l	(a7)+,d0-d7/a0-a6	;restore registers
	rts					; quit func

; internal routine which loads the correct adress of the screen in a1
loadscreen:
	tst.w	var		; is graphlib::choosescreen NULL ?
	bne	\OK		; no -> a1 is already set
	lea	$4c00,a1	; yes -> a1 = $4C00
\OK	rts


graphlib@0003:
box:
;--------------------------------------------------------------
;box(x,y,width,height)
;
;    Draws a box at (x,y)
;Input: d0.w = x
;	d1.w = y
;	d2.w = width
;	d3.w = height
;	a0.l = title of the box
;	NO REGISTERS DESTROYED
;--------------------------------------------------------------
	movem.l	d0-d7/a0-a6,-(a7)	; save registers
	moveq.w	#1,d4			;color white
	bsr        	fill	 		;clear the box
	move.w		d2,d4			;width for the func frame in d4
	move.w		d3,d5			;height for the func frame in d5
	addq.w		#1,d4
	addq.w		#1,d5
	bsr         	frame			; draw a frame
	addq.w 	#1,d0			;d0: x1+1
 	addq.w    	#1,d1			;d1:y1+1
	subq.w     	#2,d4			;d4:width-2
	subq.w      	#2,d5			;d5: height-2
	bsr		frame			;draw a frame smaller than the first one
	addq.w      	#2,d0			;x1+3
	addq.w      	#2,d1			;y1+3
	subq.w      	#4,d4			;width-6
	subq.w      	#4,d5			;height-6
	bsr		frame			; third frame smaller
	addq.w       	#1,d0			; x1+4
	addq.w		#1,d1			;y1+4
	subq.w		#7,d2			;width-7
	moveq.w	#7,d3			; height for fill:7
	clr.w		d4			;color:inverse
	bsr		fill			;inverse on the title of the box
	addq.w		#2,d0			; x1+6
	addq.w		#1,d1			; y1+5
	movem.l		d0-d2/a0-a1,-(a7)	; save registers in the stack
	clr.w		-(a7)
	jsr             	doorsos::FontSetSys
	addq.l		#2,a7			;new font:0
	clr.l		d6
	move.b		d0,d6			; d6 old font
	movem.l		(a7)+,d0-d2/a0-a1	; restore registers:they have been destroyed by fontsetsys
	move.w		#2,-(a7)
	move.l		a0,-(a7)			; address of the title
	move.w		d1,-(a7)			; y1+5
	move.w		d0,-(a7)			;x1+6
	jsr		doorsos::DrawStrXY	; disp title
	lea		10(a7),a7
	move.w		d6,-(a7)
	jsr		doorsos::FontSetSys
	addq.l		#2,a7			;restore old font
	movem.l		(a7)+,d0-d7/a0-a6	;restore registers
	rts					;quit func


;fonction cadre
graphlib@0004:
;--------------------------------------------------------------
;frame(x,y,width,height)
;
;  Draws a frame at (x,y)
;
;Input: d0.w = x
;	d1.w = y
;	d4.w = width
;	d5.w = height
;	NO REGISTERS DESTROYED
;--------------------------------------------------------------

frame:
	movem.l		d0-d7/a0-a6,-(a7)
	moveq.w	#2,d3			; color black for horiz and vert
	move.w		d0,d2
	add.w		d4,d2 			; d2 = x1 + Width
	bsr		horiz			; upper line horiz
	move.w		d1,d2			;d2:y1
	add.w		d5,d1			;d1:y1+height
	bsr		vert			;draw left vert line
	move.w		d0,d2
	addx.w		d4,d0			; d2 = x1 + Width
	bsr		horiz			;draw horiz bottom line
	move.w		d1,d2			;d2=y1+height
	subx.w		d5,d1			;d1=y1
	bsr		vert			;(d0=x1+width)right line
	movem.l		(a7)+,d0-d7/a0-a6	; restore registers
	rts 					; quit func

	
graphlib@0005:
;clear the screen
clr_scr:
	movem.l		d0-d7/a0-a6,-(a7) 	; save registers
	bsr          	loadscreen		; a1:right address of the screen
	move.w		#959,d1
\loop	clr.l		(a1)+			;clears 32 pixels and add 4 to a1
	dbra		d1,\loop			; 960*32=30720 pixels
	movem.l		(a7)+,d0-d7/a0-a6	; restore registers
	rts					; quit func

prepare:
	move.w		d0,d4
	move.w		d1,d5
	bsr		loadscreen		; a1:right address of the screen
	mulu.w		#30,d1			; a horiz line:240=30*8 pixels: 30 bytes
	add.l		d1,a1			;a1: address of the start of line d1
	lsr.w		#3,d4; d4=width/8  
	add.w		d4,a1			; a1:address of the bytes which contains the pixel
	move.w		d0,d4       		;    for example:          d0:00010101
	not.b		d4			;                                 d4:11101010
	and.b		#7,d4			;          #7:00000111  d4:00000010
						; d4= bit that correspond to the pixel in a byte:
	rts					;              76543210

graphlib@0014:
clr_scr2:
;--------------------------------------------------------------
;clr_scr(void)
;
;   clears the screen except the status line
;	NO REGISTERS DESTROYED
;--------------------------------------------------------------
	movem.l		d0-d7/a0-a6,-(a7)
	bsr		clr_scr			; clear the screen

	move.w		#LCD_HEIGHT-7,d0	;d0= y of the status line
	mulu		#30,d0			; a line= 30 bytes
	bsr		loadscreen		; right of the screen in a1
	add.l		d0,a1			; a1:address of the start of the status line
	moveq.w 	#14,d0
\line	move.w		#$FFFF,(a1)+		;draw a line: #$FFFF:11111111 11111111
	dbra		d0,\line			; a line: 30bytes=15 word
	movem.l		(a7)+,d0-d7/a0-a6
	rts

graphlib@0006:
vert:
;--------------------------------------------------------------
;vert(x,y1,y2)
;
;   Draws a vertical line
;
;Input:	d0.w = x
;	d1.w = y1
;	d2.w = y2
;
;Output: nothing
;	NO REGISTERS DESTROYED
;--------------------------------------------------------------

	movem.l		d0-d7/a0-a6,-(a7)	;save registers
	cmp.w		d1,d2
	bge		\coolvert			; if d2 greater than d1 go to coolvert 
	exg.w		d1,d2			; if d1 greater
\coolvert bsr		prepare			; go to prepare
	sub.w		d5,d2			;d2= height of the line
\bitset bset		d4,(a1) 			;set the bit d4 of the byte at a1
	lea		30(a1),a1		; a1:address of the byte a line after: a line=30 bytes
	dbra.w		d2,\bitset
	movem.l		(a7)+,d0-d7/a0-a6	;restore registers
	rts

graphlib@0007:
horiz:
;--------------------------------------------------------------
;horiz(x1,y,x2,color)
;
;   Draws an horizontal line in the specified color
;
;Input:	d0.w = x1
;	d1.w = y
;	d2.w = x2
;	d3.w = color  	0 -> Video Invert
;			1 -> White
;			2 -> Black
;
;Output: nothing
;	NO REGISTERS DESTROYED
;--------------------------------------------------------------

	movem.l		d0-d7/a0-a6,-(a7)
	cmp.w		d0,d2
	bge		\coolhr			; if d2 greater than d1go to coolhr
	exg.w		d0,d2			; if d1 greater
\coolhr
	bsr		prepare
	sub.w		d0,d2 			;d2:width of the line
	addq.w		#1,d2
\set	bchg		d4,(a1)			 ;inverse the bit d4 of the byte at a1
	tst.w		d3
	beq		\pixdone			; if color= inverse:next pixel
	bclr		d4,(a1)			;clear the bit d4 of the byte at a1
	cmp.w		#1,d3;
	beq		\pixdone			;if color= white:nextpixel
	bset		d4,(a1)			;else: sets the bit
\pixdone subq.w		#1,d2
	tst.b		d4			; if it is the last bit:76543210
	beq		\bytes
	subq.w		#1,d4			;else: next bit
\test	tst.w		d2			;d2=number of pixels to plot
	bne		\set
	movem.l		(a7)+,d0-d7/a0-a6
	rts
\bytes
 	addq.l		#1,a1			;a1: address of the next byte
	cmp.w		#8,d2			; if d2 is less or equal than 7, it remains one byte:go to finb
	blt		\finb			;else plot the whole byte
	not.b		(a1)			;inverse 
	tst.w		d3			;if color= inverse:OK
	beq		\lndone
	clr.b		(a1);
	cmp.w		#1,d3			;if color=white:OK
	beq		\lndone
	not.b		(a1)		
\lndone subq.w	#7,d2
	dbra		d2,\bytes		;d2-8
\finb	moveq.b	#7,d4			; d4= bit that correspond to the pixel in a byte:7:first bit
	bra		\test

graphlib@0008:
bigbox:
;--------------------------------------------------------------
;bigbox(void)
;
;  Draws a big box in the middle of the screen
;
;Input:	a0.l = title of the box
;
;Output: nothing
;	NO REGISTERS DESTROYED
;--------------------------------------------------------------

	movem.l	d0-d7/a0-a6,-(a7)
	clr.w		d0			;x1=0
	clr.w		d1			;y1=0
	move.w		#LCD_WIDTH-2,d2	;d2=width
	move.w		#LCD_HEIGHT-8,d3	;d3=height of screen over the status line
	bsr		box			;draw the box with this parameters
	movem.l	(a7)+,d0-d7/a0-a6
	rts

graphlib@0009:
scrtomem:
;--------------------------------------------------------------
;scrtomem(x,y,lenght,width)
;
;This function copies a part of the screen to memory.
;
;Input:d0.w = X of top left-hand corner in bytes(0<X<30)
;	d1.w = Y of top left-hand corner (0<Y<128)
;	d2.w = width in bytes (0<d2<30)  
;	d3.w = height (0<d3<128)         
;
;Output: d4.w = handle to the memory containg the part of the screen.
;	d4.w = 0 -> Not enough memory to save the screen
;	NO REGISTERS DESTROYED
;
;NOTE:This function doesn't use real coordinates because it would take much more place
;--------------------------------------------------------------

	movem.l 	d0-d3/d5/a0-a6,-(a7)	;save registers
	movem.l	d0-d3,-(a7)		;save d0-d3 in the stack
	mulu		d2,d3			;width*height ->lenght of the handle=d3
	move.l		d3,-(a7)		; lenght in stack for heapalloc
	jsr		doorsos::HeapAlloc 	;create a handle of d3 bytes
	addq.L		#4,a7	
	move.w		d0,d4			;d0=handle created
	tst.l		d0
	bne		created		;if handle wasn't created because of mem: d0=0
	movem.l	(a7)+,d0-d3		;restore all the input parameters
	bra		fin157			;quit:not enough mem
created:
	doorsos::DEREF d0,a2      		;adresse hdl->a2
	move.l		a2,a0
	movem.l 	(a7)+,d0-d3		;restore all the input parameters
	bsr		loadscreen		;right screen address in a1
	move.L		a1,a3			;a1=a3
	adda.w		d0,a3
	mulu		#30,d1			;in a line:240=30*8 pixels: 30bytes
	adda.w		d1,a3			; a3:address of the screen + x1 in bytes +y1*30bytes:FIRST A3
	subq.w		#1,d3
again: 
	bsr		copie			; copy a line:start at a3
	suba.w		d2,a3			; after copie :a3=FIRST A3+ width.Here d2=width
	lea		30(a3),a3		;nextline:30bytes after
	dbra		d3,again

fin157: movem.l 	(a7)+,d0-d3/d5/a0-a6	;restore registers
fin:	rts

copie:
	move.w		d2,d5			;d5=width
	subq.w		#1,d5	
copyLine:
	move.b		(a3)+,(a2)+		;copy the byte (8 pixels) at a3 to a2:address of the handle and increase a3 and a2
	dbra		d5,copyLine		;d5=width
	rts					;quit func

graphlib@000A:
memtoscr:

;--------------------------------------------------------------
;memtoscr(x,y,lenght,width,handle)
;
;This function copies a handle in memory to screen.
;
;Input:	d0.w = X of top left-hand corner in bytes(0<X<30)
;	d1.w = Y of top left-hand corner (0<Y<128)
;	d2.w = width in bytes (0<d2<30) 
;	d3.w = height (0<d3<128)	
;	d4.w = handle previously created by memtoscr(containing the
;					part of the screen to restore)
;
;Output:nothing
;	NO REGISTERS DESTROYED
;--------------------------------------------------------------

	movem.l		d0-d5/a0-a6,-(a7)
	doorsos::DEREF d4,a3			;address of the handle in a3
	lsr.l		#2,d4			;restore d4;deref:d4*8
	bsr		loadscreen		;right address of the screen in a1
	move.L		a1,a2
	add.w		d0,a2	
	mulu		#30,d1
	add.w		d1,a2			; a2=address of the screen+ x1 in bytes +y1*30bytes ( a line contains 30 bytes):FIRST A2
	subq.w		#1,d3
again2:
	bsr		copie			;  use copy inversing a3 and a2;a3:address of the handle 
	sub.w		d2,a2			;after copie :a2:FIRST A2 + width;here d2:width
	lea		30(a2),a2		;nextline 30 bytes after
	dbra		d3,again2
	move.w		d4,-(a7)
	jsr		doorsos::HeapFree  	;destroy the handle
	addq.l		#2,a7
	movem.l		(a7)+,d0-d5/a0-a6	;restore registers
	rts					;quit func		
graphlib@0015:
show_dialog

;----------------------------------------------------------------------------
; show_dialog()
;
; Function: Displays a dialog box.
;
; input: A6=pointer to dialog struct
; output: nothing
;
;Dialog struct:
;0(a6).w : x1 (top-left)
;2(a6).w : y1 (top-left)
;4(a6).w : x2 (down-right)
;6(a6).w : y2 (down-right)
;8(a6).w : x of the string relative to x1
;10(a6).w :y of the string relative to y1
;12(a6).l : adress of the string
;
;example of dialog structure
;
;dial	dc.w	10,15,50,40,10,5
;	dc.l	str
;
;str	dc.b	"HELLO !",0
;----------------------------------------------------------------------------

	movem.l 	d0-d7/a0-a6,-(a7)	;save registers
	move.w		(a6)+,d0		;x1 in d0
	move.w		(a6)+,d1		;y1 in d1
	move.w		(a6)+,d4		;x2 in d4
	move.w		(a6)+,d5		;y2 in d5
	sub.w		d0,d4			;d4=width
	sub.w		d1,d5			;d5=height

	lea		dialog(pc),a3
	movem.w	d0/d1/d4/d5,(a3)	;store d0,d1,d4,d5 to dialog
	bsr		clear_dialog		;clear the box
	addq.w		#1,d0			;x1+1
	addq.w		#1,d1			;y1+1
	subq.w		#2,d4			;width-2
	subq.w		#2,d5			;height-2
	bsr		frame			;draw a frame 
	addq.w		#1,d0			;x1+2
	addq.w		#1,d1			;y1+2
	subq.w		#2,d4			;width-4
	subq.w		#2,d5			;height-4
	bsr		frame			; a smaller frame
	addq.w		#2,d0			;x1+4
	addq.w		#2,d1			;y1+4
	subq.w		#4,d4			;width-8
	subq.w		#4,d5			;height-8
	bsr		frame			;a smaller frame
	move.w		#2,-(a7)
	jsr		doorsos::FontSetSys
	addq.l		#2,a7			;new font:2
	move.b		d0,d5			;d5 = old_font
	movem.w	(a3),d0/d1		;restore d0-d1 from dialog
	move.w		#4,-(a7)
	move.w		(a6)+,d2		;d2=x of text rel to x1
	move.w		(a6)+,d3		;d3=y of text rel to y1
	move.l		(a6),-(a7)		;address of the message in stack
	add.w		d0,d2			;d2=x+x1:
	add.w		d1,d3;d3=y+y1
	move.w		d3,-(a7)
	move.w		d2,-(a7)		;real coordinates of the message in stack
	jsr		doorsos::DrawStrXY	;disp the message
	lea		10(a7),a7
	move.b		d5,-(a7)
	jsr		doorsos::FontSetSys	;restore the old-font
	addq.l		#2,a7

	movem.l 	(a7)+,d0-d7/a0-a6	;restore the registers
	rts					;quit func

graphlib@0016:
clear_dialog:

;----------------------------------------------------------------------------
; clear_dialog()
;
; Function: Erases the last dialog box drawn by show_dialog(). The area
;           previously under the dialog will need to be redrawn.
;
; input:  nothing
; output: nothing
;----------------------------------------------------------------------------


	movem.l	d0-d7/a0-a6,-(a7)	;save registers
	lea		dialog(pc),a3
	movem.w	(a3),d0/d1/d2/d3	;restore with a3 the four parameters of the box fo fill
	moveq.w	#1,d4			;color: white
	bsr		fill			;clear the box
	movem.l	(a7)+,d0-d7/a0-a6	;restore the old registers
	rts

graphlib@0017:
line:
;----------------------------------------------------------------------------
; Linelib - by Jimmy Mardell <mja@algonet.se>
;
; Fargo II conversion by David Ellsworth <davidell@earthling.net>
;
; Doors OS conversion by Xavier VASSOR <xvassor@mail.dotcom.fr>
; note: I have not commented this function.
;----------------------------------------------------------------------------
 movem.l d0-d7/a0,-(a7)
 cmp.w	 d0,d2
 bcc DXpos
 exg d0,d2
 exg d1,d3
DXpos:
 move.w  d1,d4
 move.w  d1,d5
 lsl.w	 #5,d4
 lsl.w	 #1,d5
 sub.w	 d5,d4
 move.w  d0,d5
 lsr.w	 #3,d5
 add.w	 d5,d4
 move.w  d0,d5
 not	 d5
 and.b	 #$07,d5
 adda	 d4,a0
 bset.b  d5,(a0)
 move.b  d5,d6
 moveq	 #1,d5
 lsl	 d6,d5
 move.w  d2,d6
 sub.w	 d0,d6
ChY:
 cmp.w	 d1,d3
 bcc DYpos
 moveq	 #-30,d4
 move.w  d1,d7
 sub.w	 d3,d7
 bra PutP1
DYpos:
 moveq	 #30,d4
 move.w  d3,d7
 sub.w	 d1,d7
PutP1:		 ; d4 = YAI, d5 = bit, d6 = DX, d7 = DY, A0 = Ptr
 cmp.w	 d0,d2
 bne DotsNE
 cmp.w	 d1,d3
 beq LineDone
DotsNE:
 cmp.w	 d6,d7
 bcc DY_Greater
 move.l  d6,d2
 subq	 #1,d2	 ; d2 = number of pixels to be plot
 move.w  d7,d3
 sub.w	 d6,d3	 ; d3 = dy-dx
 asl.w	 #1,d3	 ; d3 = ai
 lsl.w	 #1,d7	 ; d7 = bi
 sub.w	 d7,d6
 neg	 d6	 ; d6 = d
RepX:
 or.w	 d6,d6
 bmi X_DNeg
 adda	 d4,a0
 add.w	 d3,d6
 bra IncX
X_DNeg:
 add.w	 d7,d6
IncX:
 ror.b	 #1,d5
 bcc X_SameByte
 addq	 #1,a0
X_SameByte:
 or.b	 d5,(a0)
 dbra	 d2,RepX
 bra LineDone
DY_Greater:
 move.l  d7,d3
 subq	 #1,d3	 ; d3 = number of pixels to be plot
 move.w  d6,d2
 sub.w	 d7,d2	 ; d2 = dx-dy
 lsl.w	 #1,d2	 ; d2 = ai
 lsl.w	 #1,d6	 ; d6 = bi
 sub.w	 d6,d7
 neg	 d7	 ; d7 = d
RepY:
 or.w	 d7,d7
 bmi Y_DNeg
 ror.b	 #1,d5
 bcc Y_SameByte
 addq	 #1,a0
Y_SameByte:
 add.w	 d2,d7
 bra IncY
Y_DNeg:
 add.w	 d6,d7



IncY:
 adda	 d4,a0
 or.b	 d5,(a0)
 dbra	 d3,RepY
LineDone:
 movem.l (a7)+,d0-d7/a0
 rts

graphlib@000D:
choosescreen:		;variable that indicates if a1 is the right address of the screen

var	dc.w	0

graphlib@000E
gray2:
        movem.l d0-d7/a0-a6,-(a7)       ;save copy of all registers on stack

      lea handle(pc),a6
	move.w (a6),d0
	beq graylib_fail		;vite plantage si libre bloc vide

	move.w d0,-(a7)
	jsr doorsos::HeapFree
	addq.l #2,a7

	clr.w (a6)+			;handle

	move.w (a6),d0		;dummyhandle
	beq suitegray2

	move.w d0,-(a7)
	jsr doorsos::HeapFree
	addq.l #2,a7

	clr.w (a6)

suitegray2:
	move.l #LCD_MEM,plane0
	move.l oldint1(pc),$40064        ;restore old auto-int 1
	jsr doorsos::PortRestore        ;tells tios to draw to LCD_MEM

graylib_fail:                           ;on error (not enough free mem)
        movem.l (a7)+,d0-d7/a0-a6       ;restore copy of registers from stack
	clr.l d0                        ;clear d0 (d0 = 0 indicates error)
	RTS                             ;return

graphlib@000F
gray4:	;thanks to Scott Noveck for his source

	movem.l d0-d7/a0-a6,-(a7)       ;save copy of all registers on stack

	move.l #3840*2+4,-(a7)    ;two planes + 4 bytes
	jsr doorsos::HeapAllocHigh          ;allocate memory
	addq.l #4,a7                     ;restore stack pointer

	move.w d0,handle               ;otherwise, d0 contains the handle
	beq graylib_fail                ;  then not enough free memory

	DEREF d0,a5                     ;get the address in a5

	move.w #30,(a5)+		;tios bitmap format - 30 bytes wide
	move.w #128,(a5)+		;tios bitmap format - 128 lines high
	move.w #127,-(a7)               ;push height-1
	move.w #239,-(a7)               ;push width-1

	move.l a5,-(a7)                ;push pointer to plane 0
	jsr doorsos::PortSet            ;portset tells tios to draw to plane 1
	addq.l #8,a7                     ;restore stack

	move.l a5,plane0               ;and save it

	lea 30*128(a5),a5                ;increase a5 to point to plane 1
	move.l a5,plane1		;save address of plane 1

	move.l $64,oldint1            ;save old auto-int 1 address
	move.l #int_1_g4,$40064               ;install new auto-int 1 routine
	movem.l (a7)+,d0-d7/a0-a6       ;restore registers from stack
	st.b d0	                        ;set true d0 (d0.b = $ff)
	RTS                             ;return successful!

graphlib@0010
gray7:		;impossible sur HW2 !

	bsr gray4

	move.l	#int_1_g7,$40064

	move.l #3840,-(a7)
	jsr doorsos::HeapAllocHigh		;cre un bloc bidon
	move.w d0,dummyhandle
	move.w d0,-(a7)
	jsr doorsos::HeapDeref
	addq.l #6,a7
	move.l a0,plane2		;pourra crire n'importe quoi ici...
	RTS

int_1_g4:
	move.w #$2700,SR
	subq.w #1,vbl_phase
	bne int_1_skip

	movem.l d0-d7/a0-a6,-(a7)

	lea vbl_phase(pc),a0
	move.w #3,(a0)

	lea	phase(pc),a0
	tst.w (a0)		;phase
	beq lightplane

	addq.w #1,(a0)
	cmp.w #2,(a0)
	beq darkplane

	clr.w (a0)
	bra copywrap

darkplane:
	move.l plane0,a0
	bra copyplane

lightplane:
	addq.w #1,(a0)
	move.l plane1,a0

copyplane:
	lea	LCD_MEM,a1

	tst.b CALCULATOR
	bne screen92
	lea	30(a0),a2
	lea	30(a1),a3

	moveq #49,d0
copyscreenloop:
	move.l (a0)+,(a1)+		;inutile de faire movem sur les 89
	move.l (a0)+,(a1)+		;116 cycles pour une ligne!
	move.l (a0)+,(a1)+
	move.l (a0)+,(a1)+
	move.l (a0)+,(a1)+
	lea 40(a0),a0
	lea 40(a1),a1
	dbra d0,copyscreenloop

	moveq	#50,d0
copyscreenloop2:
	move.l	(a2)+,(a3)+
	move.l	(a2)+,(a3)+
	move.l	(a2)+,(a3)+
	move.l	(a2)+,(a3)+
	move.l	(a2)+,(a3)+
	lea	40(a2),a2
	lea	40(a3),a3
	dbra	d0,copyscreenloop2


	bra copywrap

screen92:
	moveq #39,d0		;48*40*2=3840
copy92:
	movem.l (a0)+,d1-d7/a2-a6
	movem.l d1-d7/a2-a6,(a1)
	lea	48(a1),a1
	movem.l (a0)+,d1-d7/a2-a6
	movem.l d1-d7/a2-a6,(a1)
	lea	48(a1),a1
	dbra	d0,copy92

copywrap:
	movem.l (a7)+,d0-d7/a0-a6
int_1_skip:
	move.l	oldint1(pc),-(a7)
	rts


int_1_g7:
	move.w #$2700,SR
	subq.w #1,vbl_phase
	bne int_1_skip

	movem.l d0-d7/a0-a6,-(a7)

	lea vbl_phase(pc),a0
	move.w #2,(a0)

	lea	phase(pc),a0

	addq.w	#1,(a0)
	and.w	#7,(a0)

	tst.w (a0)
	beq blackplane

	cmp.w #3,(a0)
	beq grayplane

	cmp.w	#4,(a0)
	beq	whiteplane

	bra copywrap

whiteplane:
	move.l	plane0,a0
	bra	copyplane
grayplane:
	move.l	plane1,a0
	bra	copyplane

blackplane:
	move.l plane2,a0
	bra copyplane


graphlib@0011
plane0		dc.l $4C00
graphlib@0012
plane1		dc.l 0
graphlib@0013
plane2		dc.l 0

oldint1	dc.l	0
handle		dc.w	0
dummyhandle	dc.w	0
vbl_phase	dc.w	3
phase		dc.w	0
table		ds.w	6

dialog		dc.w	0	;x
		dc.w	0	;y
		dc.w	0	;width
		dc.w	0	;height

	end